#include <M5Stack.h>
#include <M5GFX.h>
#include "UNIT_SCALES.h"

M5GFX display;
M5Canvas canvas(&display);
UNIT_SCALES scales;

void setup() {
    M5.begin();
    display.begin();
    canvas.setColorDepth(8);  // mono color
    canvas.setFont(&fonts::efontCN_12);
    canvas.createSprite(display.width(), display.height());
    canvas.setTextSize(2);
    while (!scales.begin(&Wire, 21, 22, DEVICE_DEFAULT_ADDR)) {
        Serial.println("scales connect error");
        M5.Lcd.print("scales connect error");
        delay(1000);
    }
    scales.setLEDColor(0x000010) ;

    scales.setLPFilter(1) ; // 0~1 : DEF 1
    scales.setAvgFilter(10);  // 0~50 : DEF 10
    scales.setEmaFilter(10);  // 0~99 : DEF 10
}

void loop() {
    int32_t weightInt = scales.getWeightInt();
    if (weightInt < 0) weightInt = 0 ;

    canvas.fillSprite(BLACK);

    canvas.setTextColor(TFT_WHITE, TFT_BLACK);
    canvas.setTextFont(7);
    canvas.setTextSize(2);
    canvas.setCursor(5,50);
    canvas.printf("%4.4d",weightInt/100) ;
    canvas.setTextFont(4);
    canvas.setTextSize(1);
    canvas.setCursor(260,120);
    canvas.printf(".%02d",weightInt%100) ;

    canvas.setTextFont(4);
    canvas.setTextSize(1);
    canvas.setTextColor(ORANGE); canvas.drawString("[ZERO]", 120, 210);

    canvas.pushSprite(0, 0);
    M5.update();
    if (M5.BtnB.wasPressed()) {
        scales.setOffset();
    }
}
